<?php
/**
 * @file
 * This set of functions handle obtaining and processing a RADIUS response
 */

/**
 * Process a RADIUS response from the server
 *
 * @return array
 *   An array of response items
 * @todo add handling of accounting to this function
 */
function radius_client_response($radius) {
  $response = array();

  while ($prop = radius_get_attr($radius)) {
    if (!is_array($prop)) {
        watchdog('radius_client',
          'Error getting attribute: @attribtue',
          array(
            '@attribute' => radius_strerror($radius),
          ),
          WATCHDOG_WARNING);
        return $resopnse;
    }
    if ($prop['attr'] == RADIUS_VENDOR_SPECIFIC) {
      $data = radius_get_vendor_attr($prop['data']);
      $vendor = radius_dictionary_get_vendor_name($data['vendor']);
      $attribute_data = radius_dictionary_lookup_attribute_by_id($data['attr'], $vendor);
      switch ($attribute_data['type']) {
        case 'string':
          $value = radius_cvt_string($data['data']);
          break;
        case 'int':
          $value = radius_cvt_int($data['data']);
          break;
        case 'ipaddr':
          $value = radius_cvt_addr($data['data']);
          break;
        default:
          $value = $prop['data'];
          break;
      }
      $response[] = array(
        'vendor' => $vendor,
        'attribute' => $attribute_data['name'],
        'value' => $value,
        'rawAttribute' => $data,
      );
    }
    else {
      // Standard attributes.
      $attribute_data = radius_dictionary_lookup_attribute_by_id($prop['attr']);
      switch ($attribute_data['type']) {
        case 'string':
          $value = radius_cvt_string($prop['data']);
          break;
        case 'int':
          $value = radius_cvt_int($prop['data']);
          break;
        case 'ipaddr':
          $value = radius_cvt_addr($prop['data']);
          break;
        default:
          $value = $prop['data'];
          break;
      }
      $response[] = array(
        'vendor' => NULL,
        'attribute' => $attribute_data['name'],
        'value' => $value,
        'rawAttribute' => $prop,
      );
    }
  }
  return $response;
}
