<?php

/**
 * @file
 * This file contains no working PHP code; it exists to provide additional
 * documentation for doxygen as well as to document hooks in the standard
 * Drupal manner
 */

/**
 * Provides options passed to the RADIUS server
 *
 * @return array
 *   $options
 *
 * RADIUS options are sent whenever authentication and access requests
 * are sent to the RADIUS server.
 *
 * This hook provides optiosn for modules to implement their own options to
 * these messages.
 */
function hook_radius_options() {
  $options[] = array(
    'attribute' => radius_dictionary_lookup_attribute_by_name('Service-Type'),
    'value' => 1,
  );

  $options[] = array(
    'attribute' => radius_dictionary_lookup_attribute_by_name('Nomadix-Logoff-URL', 'Nomadix'),
    'value' => 'http://www.rwts.com.au/',
  );

  return $options;
}

/**
 * Provides option to alter options passed to radius server
 *
 * @param array $options
 *   The options array that will be changed
 *
 * RADIUS options are sent whenever authentication and access requests
 * are sent to the RADIUS server.
 *
 * This hook provides optiosn for modules to alter the options sent by other
 * modules.
 */
function hook_radius_options_alter(&$options) {
  $service_type_avp = radius_dictionary_lookup_attribute_by_name('Service-Type');
  foreach ($options as &$option) {
    if ($option['attribute'] == $service_type_avp) {
      $option['value'] = 6;
    }
  }
}
